package com.persagy.server.syn.models.tools

import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.models.entities.objects.Shaft
import com.persagy.server.syn.Opts
import com.persagy.server.syn.controllers.obj.ObjectFromToControllers
import com.persagy.service.SObjectService
import com.persagy.service.utils.SSpringContextUtil
import org.slf4j.LoggerFactory

/**
 * 竖井转换工具
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/21 20:22
 */
object ShaftUtil {

    /** 日志 */
    private val logger = LoggerFactory.getLogger(ObjectFromToControllers::class.java)
    /** 信息点 */
    private val dictDefFuncIdService = SObjectService(SMybatisDao(DefFuncId::class.java))
    /** 配置 */
    private val opts: Opts by lazy {
        SSpringContextUtil.getBean(Opts::class.java) as Opts
    }

    fun shaftDataConversion(projectId: String,groupCode: String, mapObj: HashMap<String, Any?>): Shaft {

        /** 查建楼层型字典 */
        val dictDefFuncIdList = dictDefFuncIdService.select(SFilter.eq("groupCode", groupCode), SFilter.eq("classCode", "floor")).exec()
        val mapEx = HashMap<String, Any?>()
        val mapCode = HashMap<String, Any?>()

        for (explainProject in dictDefFuncIdList) {
            mapEx[explainProject.code!!] = explainProject.firstName
            if (!explainProject.secondName.isNullOrEmpty()) {
                mapCode[explainProject.code!!] = explainProject.secondName
            }
        }
        /** 设定参数 */
        val settingParam = HashMap<String, Any?>()
        /** 基本设定参数 */
        val basicSetParam = HashMap<String, Any?>()

        val shaft = Shaft()
        shaft.projectId = projectId
        for (key in mapObj.keys) {
            val containsKey = mapEx.containsKey(key)
            if (containsKey) {
                val value = mapEx[key]
                if (value == "设定参数") {
                    /** 通讯参数 */
                    val contains = mapCode.containsKey(key)
                    if (contains) {
                        val any = mapCode[key].toString()
                        if (any == "基本设定参数"){
                            basicSetParam[key] = mapObj[key]
                        }
                    } else {
                        /** 结构信息 */
                        settingParam[key] = mapObj[key]
                    }
                } else {
                    when (key) {
                        "name" -> shaft.name = mapObj[key].toString()
                        "localID" -> shaft.localId = mapObj[key].toString()
                        "localName" -> shaft.localName = mapObj[key].toString()
                        "bimId" -> shaft.bimId = mapObj[key].toString()
                        "id" -> shaft.id = mapObj[key].toString()
                        "cadId" -> shaft.cadId = mapObj[key].toString()
                        "qRCodePic" -> shaft.qRCodePic = mapObj[key].toString()
                        "defaultQRCode" -> shaft.defaultQRCode = mapObj[key].toString()
                    }
                }

            }
//            else if (key.startsWith("ctm-")) {
//                /** 自定义 */
//                customParam[key] = infos[key]
//            }
        }

        if (!basicSetParam.isNullOrEmpty()){
            settingParam["basicSetParam"] = basicSetParam
        }
        if (!settingParam.isNullOrEmpty()){
            shaft.settingParam = settingParam
        }

        return shaft
    }


}